package org.nakedobjects.nos.store.file;

import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.persist.SerialOid;


/**
 * A logical collection of elements of a specified type
 */
public class CollectionData extends Data {
    private ReferenceVector elements;

    public CollectionData(final NakedObjectSpecification type, final SerialOid oid, final FileVersion version) {
        super(type, oid, version);
        elements = new ReferenceVector(oid);
    }

    public void addElement(final SerialOid elementOid) {
        elements.add(elementOid);
    }

    public void removeElement(final SerialOid elementOid) {
        elements.remove(elementOid);
    }

    public ReferenceVector references() {
        return elements;
    }

    public String toString() {
        return "CollectionData[type=" + getClassName() + ",elements=" + elements + "]";
    }
}
// Copyright (c) Naked Objects Group Ltd.
