package org.nakedobjects.nos.store.file;

import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.persist.SerialOid;


public abstract class Data {
    private final String type;
    private final SerialOid oid;
    private FileVersion version;

    Data(NakedObjectSpecification type, SerialOid oid, FileVersion version) {
        this.type = type.getFullName();
        this.oid = oid;
        this.version = version;
    }

    public SerialOid getOid() {
        return oid;
    }

    public FileVersion getVersion() {
        return version;
    }

    public String getClassName() {
        return type;
    }

    public boolean equals(final Object obj) {
        if (obj == this) {
            return true;
        }

        if (obj instanceof Data) {
            return ((Data) obj).type.equals(type) && ((Data) obj).oid.equals(oid);
        }

        return false;
    }

    public int hashCode() {
        int h = 17;
        h = 37 * h + type.hashCode();
        h = 37 * h + oid.hashCode();
        return h;
    }

}
// Copyright (c) Naked Objects Group Ltd.
