package org.nakedobjects.nos.store.file;

import org.nakedobjects.nof.core.persist.SerialOid;
import org.nakedobjects.nof.core.util.ToString;

import java.util.Vector;



public class ReferenceVector {
    private final SerialOid oid;
    private final Vector elements = new Vector();

    public ReferenceVector(final SerialOid oid) {
        this.oid = oid;
    }

    public void add(final SerialOid oid) {
        elements.addElement(oid);
    }

    public void remove(final SerialOid oid) {
        elements.removeElement(oid);
    }

    public SerialOid getOid() {
        return oid;
    }

    public int size() {
        return elements.size();
    }

    public SerialOid elementAt(final int index) {
        return (SerialOid) elements.elementAt(index);
    }

    public boolean equals(final Object obj) {
        if (obj == this) {
            return true;
        }

        if (obj instanceof ReferenceVector) {
            return ((ReferenceVector) obj).elements.equals(elements);
        }

        return false;
    }

    public int hashCode() {
        int h = 17;
        h = 37 * h + elements.hashCode();
        return h;
    }

    public String toString() {
        ToString str = new ToString(this);
        str.append("oid", oid);
        str.append("refs", elements);
        return str.toString();
    }
}
// Copyright (c) Naked Objects Group Ltd.
